
#    Copyright (C) 2011  Stefano Palazzo <stefano.palazzo@gmail.com>

#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.

#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

import urllib
import urllib2
import json


def log(message):
    print "\33[1m%s\33[m" % message


def google_search(q):
    '''
    This returns the empty list in case of an error, else
    it returns a list of dicts containing the 'url' and
    'titleNoFormatting' keys, and perhaps others, though
    they are not used anywhere.

    '''
    print "making a google search for '%s'" % q
    try:
        query = urllib.urlencode({'q': q})
        url = ('http://ajax.googleapis.com/ajax/services/search/web?v=1.0&%s'
          % (query))
        search_results = urllib2.Request(
            url, None, {'Referer': "http://unity.ubuntu.com/"})  # TODO
        results = json.loads(urllib2.urlopen(search_results).read())
        return results['responseData']['results']
    except Exception, e:
        log(repr(e))  # This can be improved, how does google throw errors?
        return []
